Bug 147777 - libsafe causes programs using libc-5.4.46-4 to segfault
libsafe causes programs using libc-5.4.46-4 to segfault
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: libsafe (Show other bugs)
3
athlon Linux
medium Severity medium
: ---
: ---
Assigned To: Steve Grubb
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2005-02-11 02:57 EST by james
Modified: 2007-11-30 17:11 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-01-19 19:08:05 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description james 2005-02-11 02:57:02 EST
From Bugzilla Helper:
User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; X11; Linux i686) Opera 
7.54  [en]

Description of problem:
This depends on the mix of libraries.

Using, in particular, libc-5.4.46-4.i686.rpm and ld.so-1.9.9-11.i686.
rpm to run /opt/WordPerfect8/wpbin/xwp will cause xwp to segfault.  
Removing libsafe allows xwp to run normally.

$ ldd /opt/WordPerfect8/wpbin/xwp
        libXt.so.6 => /usr/lib/libc5/libXt.so.6 (0xb7f92000)
        libX11.so.6 => /usr/lib/libc5/libX11.so.6 (0xb7f00000)
        libXpm.so.4 => /usr/lib/libc5/libXpm.so.4 (0xb7ef2000)
        libm.so.5 => /usr/lib/libc5/libm.so.5 (0xb7eea000)
        libc.so.5 => /usr/lib/libc5/libc.so.5 (0xb7e2a000)
        libSM.so.6 => /usr/lib/libc5/libSM.so.6 (0xb7e22000)
        libICE.so.6 => /usr/lib/libc5/libICE.so.6 (0xb7e0e000)

If instead, using libc-5.3.12-31.i386.rpm and ld.so-1.9.9-11.i686.
rpm, running xwp gives
$ /opt/WordPerfect8/wpbin/xwp
 /opt/WordPerfect8/wpbin/xwp: can't resolve symbol '_rtld_global'
 /opt/WordPerfect8/wpbin/xwp: can't resolve symbol '_rtld_global_ro'

Those symbols seem to be from /lib/libdl.so.2, called by /lib/
libsafe.so.2 right after /usr/i386-glibc21-linux/lib/ld-linux.so.2 is 
accessed.

I see the exact same behavior, using each library, with an old libc 
color-ls.



Version-Release number of selected component (if applicable):
libsafe-2.0-16.fdr.1.rh80

How reproducible:
Always

Steps to Reproduce:
1.
2.
3.
    

Additional info:
Comment 1 Steve Grubb 2005-02-11 10:05:06 EST
The messages above seem to indicate that you are using a version of libsafe
compiled for a different glibc than what you are using. I think this is a design
limitation of libsafe. 

libsafe would need to be compiled against the old libc-5 library to work for
those, which might make it not work for anything newer. I don't really think
this is supportable in a generic way.
Comment 2 james 2005-02-11 16:45:03 EST
Yes, the base libc is glibc from glibc-2.3.4-2.fc3 and libc-5 is a compatability
library.  I looked at the libsafe Avaya Labs Research website.  They
specifically say:

 Notes
  * libc5 linked programs are not supported.

So I guess that is that.  Still, if someone really wanted to, there might be
ways to work with LD_PRELOAD or /etc/ld.so.preload, or possibly LD_LIBRARY_PATH,
so that libsafe was not invoked for libc-5 programs.  A wrapper script could
clear LD_PRELOAD before running a libc-5 program, for instance.
Comment 3 Christian Iseli 2007-01-19 18:48:05 EST
FC3 and FC4 have now been EOL'd.

Please check the ticket against a current Fedora release, and either adjust the
release number, or close it if appropriate.

Thanks.

Your friendly BZ janitor :-)
Comment 4 Steve Grubb 2007-01-19 19:08:05 EST
Closing this since it doesn't apply to current releases

Note You need to log in before you can comment on or make changes to this bug.